/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.52 by edhill, Wed Dec 1 16:59:42 2004 UTC revision 1.71 by jmc, Tue Aug 16 17:12:46 2005 UTC
# Line 27  usage() Line 27  usage()
27      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
28      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
29      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
30        echo "  (-odir) STRING           used to build output directory name"
31        echo "                             (DEF=\"hostname\")"
32      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"
33      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
34      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
# Line 95  testoutput_for_prop() Line 97  testoutput_for_prop()
97      fi      fi
98      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/output.txt ]; then
99          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
100          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
101          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 3 ]; then
102              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
103                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
104              fi              fi
# Line 110  testoutput_for_prop() Line 112  testoutput_for_prop()
112          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
113      fi      fi
114      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
115      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
116      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 3 ]; then
117          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
118              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
119          fi          fi
120          return 99          return 99
121      fi      fi
122        if [ $lncntA -ne $lncntB ]; then
123            if [ $verbose -gt 0 ]; then
124                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
125            fi
126            return 99
127        fi
128        non_real_numb=`egrep -c -i 'NAN|INF' tmp1.txt`
129        if [ $non_real_numb -gt 0 ]; then
130            echo testoutput_for_prop: output.txt has $non_real_numb not real numbers 1>&2
131            return 99
132        fi
133      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
134          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2
135      fi      fi
# Line 294  genmakemodel() Line 307  genmakemodel()
307              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
308                  command="$command -ieee"                  command="$command -ieee"
309              fi              fi
310                if test "x$MPI" = xt ; then
311                    command="$command -mpi"
312                fi
313              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
314              $command > make.log 2>&1              $command > make.log 2>&1
315              RETVAL=$?              RETVAL=$?
# Line 339  makeclean() Line 355  makeclean()
355      fi      fi
356  }  }
357    
358    postclean()
359    {
360        # postclean directory
361        if test "x$POSTCLEAN" = xt ; then
362            (
363                cd $1;
364                if test -r Makefile ; then
365                    $MAKE CLEAN >> /dev/null 2>&1
366                fi
367                exit 0
368            )
369        fi
370    }
371    
372  makedependmodel()  makedependmodel()
373  {  {
374      # makedependmodel directory      # makedependmodel directory
# Line 450  linkdata() Line 480  linkdata()
480              if test "x$ADM" = x ; then              if test "x$ADM" = x ; then
481                  files=`( cd ../input ; ls -1 | grep -v CVS )`                  files=`( cd ../input ; ls -1 | grep -v CVS )`
482                  for i in $files ; do                  for i in $files ; do
483                      if test ! -d "../input/"$i ; then                      if test ! -d "../input/"$i -a ! -f $i ; then
484                          ln -sf "../input/"$i $i                          ln -sf "../input/"$i $i
485                      fi                      fi
486                  done                  done
# Line 520  createcodelet() Line 550  createcodelet()
550  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
551    int linnum,best,lncnt;    int linnum,best,lncnt;
552    double a,b,abave,relerr;    double a,b,abave,relerr;
553    best = -16;    best = -22;
554    lncnt = 0;    lncnt = 0;
555    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & (lncnt+=1) < 999 )  {
556      scanf("%d", &linnum);      scanf("%d", &linnum);
# Line 529  int main( int argc, char** argv )  { Line 559  int main( int argc, char** argv )  {
559      abave = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
560      if (abave > 0.0) {      if (abave > 0.0) {
561        relerr=fabs(a-b)/abave;        relerr=fabs(a-b)/abave;
562        if (relerr > 0.0) {        if (relerr > 0.0) { linnum = (int)rint(log10(relerr)); }
563          linnum = (int)log10(relerr);        else { linnum = -16 ; }
564          best = (best > linnum) ? best : linnum;        best = (best > linnum) ? best : linnum;
       }  
     }  
     else {  
       if (best == -16 && abave != 0)  best = -22;  
565      }      }
566    }    }
567    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
# Line 543  int main( int argc, char** argv )  { Line 569  int main( int argc, char** argv )  {
569    return 0;    return 0;
570  }  }
571  EOF  EOF
572      cc -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tmp_cmpnum tmp_cmpnum.c -lm
573    
574      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tmp_cmpnum ]; then
575          echo "OK"          echo "OK"
576          return 0          return 0
577      else      else
578          echo          echo
579          echo "ERROR: failed to compile comparison code"          echo "ERROR: failed to compile comparison code -- please specify"
580            echo "  a C compiler using the CC environment variable."
581          exit 1          exit 1
582      fi      fi
583  }  }
# Line 630  QUICK=f Line 657  QUICK=f
657  NOGENMAKE=f  NOGENMAKE=f
658  NOCLEAN=f  NOCLEAN=f
659  NODEPEND=f  NODEPEND=f
660    POSTCLEAN=f
661    
662  BASH=  BASH=
663  OPTFILE=NONE  OPTFILE=NONE
# Line 639  MPACKDIR="../tools/mpack-1.6" Line 667  MPACKDIR="../tools/mpack-1.6"
667  HAVE_MPACK=  HAVE_MPACK=
668  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
669  COMMAND=  COMMAND=
670  MAKE=make  if test "x$MAKE" = x ; then
671        MAKE=make
672    fi
673    if test "x$CC" = x ; then
674        CC=cc
675    fi
676  JOBS=  JOBS=
677  MPI=f  MPI=f
678    OUTDIR=
679  DELDIR=  DELDIR=
680    
681  ADM=  ADM=
# Line 698  for ac_option ; do Line 732  for ac_option ; do
732          -make=* | --make=*)          -make=* | --make=*)
733              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
734    
735            -odir | --odir)
736                ac_prev=OUTDIR ;;
737            -odir=* | --odir=*)
738                OUTDIR=$ac_optarg ;;
739    
740          -ptracers | --ptracers | -ptr | --ptr)          -ptracers | --ptracers | -ptr | --ptr)
741              ac_prev=PTRACERS_NUM ;;              ac_prev=PTRACERS_NUM ;;
742          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
# Line 707  for ac_option ; do Line 746  for ac_option ; do
746          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
747    
748          -clean | --clean)          -clean | --clean)
749              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
750    
751          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
752              QUICK=t ;;              QUICK=t ;;
# Line 718  for ac_option ; do Line 757  for ac_option ; do
757          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
758              NODEPEND=t ;;              NODEPEND=t ;;
759    
760            -postclean | --postclean | -pc | --pc)
761                POSTCLEAN=t ;;
762    
763          -mpi) MPI=t ;;          -mpi) MPI=t ;;
764    
765          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
# Line 784  MACH=`hostname` Line 826  MACH=`hostname`
826  UNAMEA=`uname -a`  UNAMEA=`uname -a`
827  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
828  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
829    if test "x$OUTDIR" != x ; then
830        BASE="tr_"$OUTDIR"_"$DATE"_"
831    fi
832  DNUM=0  DNUM=0
833  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
834  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 873  for dir in $TESTDIRS ; do Line 918  for dir in $TESTDIRS ; do
918          if test -r $dir/input/Makefile ; then          if test -r $dir/input/Makefile ; then
919              ( cd $dir/input ; make CLEAN )              ( cd $dir/input ; make CLEAN )
920          fi          fi
921            (
922                cd $dir
923                rm -rf tr_run.*
924            )
925          continue          continue
926      fi      fi
927    
# Line 881  for dir in $TESTDIRS ; do Line 930  for dir in $TESTDIRS ; do
930      fout=      fout=
931      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
932          fout=$dir"/results/output.txt"          fout=$dir"/results/output.txt"
         check_for_add_mon_output  $fout  
933      else      else
934          fout=$dir"/results_ad/output.txt_adm"          fout=$dir"/results_ad/output.txt_adm"
935      fi      fi
# Line 889  for dir in $TESTDIRS ; do Line 937  for dir in $TESTDIRS ; do
937          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
938          continue          continue
939      fi      fi
940        if test "x$ADM" = x ; then
941            check_for_add_mon_output  $fout
942        fi
943    
944      # Check for additional types of monitor output      # Check for additional types of monitor output
945    
# Line 966  for dir in $TESTDIRS ; do Line 1017  for dir in $TESTDIRS ; do
1017          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1018          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1019    
         OLD_COMMAND=$COMMAND  
         COMMAND="./mitgcmuv > output.txt"  
1020          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1021              test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1022              mkdir "$dir/tr_run.$ex"              for ldir in input.$ex input ; do
1023              links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`                  (
1024                        cd "$dir/$ldir" > /dev/null 2>&1
1025                        ls -1 2>/dev/null \
1026                            | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'
1027                    ) > tr_exrun_links
1028                    (
1029                        cd "$dir/tr_run.$ex"
1030                        cat ../../tr_exrun_links | while read i ; do
1031                            if test ! "x$i" = x ; then
1032                                test ! -r $i  &&  ln -s "../"$ldir"/"$i $i
1033                            fi
1034                        done
1035                    )
1036                    test -e tr_exrun_links  &&  rm -f tr_exrun_links
1037                done
1038                ldir=build
1039                (
1040                    cd "$dir/$ldir" > /dev/null 2>&1
1041                    ls -1 Makefile *.[fFhco] mitgcmuv  2>/dev/null \
1042                        | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'
1043                ) > tr_exrun_links
1044              (              (
1045                  cd "$dir/tr_run.$ex"                  cd "$dir/tr_run.$ex"
1046                  for i in $links; do                      cat ../../tr_exrun_links | while read i ; do
1047                      ln -s ../input/$i $i                          if test ! "x$i" = x ; then
1048                  done                              test ! -r $i  &&  ln -s "../"$ldir"/"$i $i
1049              )                          fi
1050              links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`                      done
             (  
                 cd "$dir/tr_run.$ex"  
                 for i in $links; do  
                     test -e $i  &&  rm -f $i  
                     ln -s ../input.$ex/$i $i  
                 done  
                 ln -s ../$builddir/mitgcmuv mitgcmuv  
1051              )              )
1052                test -e tr_exrun_links  &&  rm -f tr_exrun_links
1053              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1054                  && results=`testoutput $dir tr_run.$ex "."$ex`                  && results=`testoutput $dir tr_run.$ex "."$ex`
1055              fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`              fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
# Line 1000  for dir in $TESTDIRS ; do Line 1063  for dir in $TESTDIRS ; do
1063              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1064              echo "tdir='$dir'" >> $CDIR"/summary.txt"              echo "tdir='$dir'" >> $CDIR"/summary.txt"
1065          done          done
         COMMAND=$OLD_COMMAND  
1066      else      else
1067          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
1068          fres=$fres"$results   $dir"          fres=$fres"$results   $dir"
# Line 1012  for dir in $TESTDIRS ; do Line 1074  for dir in $TESTDIRS ; do
1074          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1075          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1076      fi      fi
1077    
1078        postclean $dir/$builddir
1079            
1080      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1081            
# Line 1053  fi Line 1117  fi
1117  rm -f tmp_cmpnum.c tmp_cmpnum  rm -f tmp_cmpnum.c tmp_cmpnum
1118    
1119  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1120      cat $SUMMARY      cat $SUMMARY | sed 's/ -- -- -- --//g'
1121      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1122          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1123      fi      fi
1124      cat $SUMMARY > tr_out.txt      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt
1125  fi  fi
1126    
1127  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.52  
changed lines
  Added in v.1.71

  ViewVC Help
Powered by ViewVC 1.1.22